package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.FactomDataEntryMarshaller;
import io.accumulatenetwork.sdk.support.serializers.Hex2DDeserializer;
import io.accumulatenetwork.sdk.support.serializers.Hex2DSerializer;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("FactomDataEntry")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class FactomDataEntry extends FactomDataEntryMarshaller {
	private byte[] accountId;
	private byte[] data;
	private byte[][] extIds;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getAccountId() {
	    return accountId;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setAccountId(final byte[] value) {
	    this.accountId = value;
	}

	public FactomDataEntry accountId(final byte[] value) {
	    setAccountId(value);
	    return this;
	}
	public FactomDataEntry accountId(final String value) {
		try {
			setAccountId(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getData() {
	    return data;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setData(final byte[] value) {
	    this.data = value;
	}

	public FactomDataEntry data(final byte[] value) {
	    setData(value);
	    return this;
	}
	public FactomDataEntry data(final String value) {
		try {
			setData(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	@JsonDeserialize(using = Hex2DDeserializer.class)
	public byte[][] getExtIds() {
	    return extIds;
	}
	@JsonSerialize(using = Hex2DSerializer.class)
	public void setExtIds(final byte[][] value) {
	    this.extIds = value;
	}

	public FactomDataEntry extIds(final byte[][] value) {
	    setExtIds(value);
	    return this;
	}
}
